﻿/********************************************************************************/
/* 	gamecore.d																	*/
/*------------------------------------------------------------------------------*/
/*	製作		D.K（あるふぁ～秘密基地）										*/
/*	製作開始	2008/05/22														*/
/*	MAIL		dk@red.interq.or.jp												*/
/*	URL			http://maglog.jp/alpha-secret-base/								*/
/*																				*/
/*	このソースは「やわらかライセンス」の元で配布されています。					*/
/*-更新履歴---------------------------------------------------------------------*/
/*	2008/05/22	初版															*/
/*-その他-----------------------------------------------------------------------*/
/*	なし																		*/
/********************************************************************************/

private import state;
private import hell2;
private import boot;
private import actor;
private import vector;
private import keypad;
private import clickable;
//private import configparser;

import config;

//private import std.math;
private import map;
private import fmfloader;

/********************************************************************************/

//ConfigParser configparser = null;
const static string CONFIG_PATH = "config.ini";


/* GameMain *********************************************************************/
/*	ゲーム本体の状態															*/
/********************************************************************************/

class GameMain : GameState
{
public:
	//-----------------------------------------------------------------------------
	//システム制御用
	//-----------------------------------------------------------------------------
	enum SCENE{
		INIT = 0,
		START,
		MAIN,
		CLEAR,
		END,
		PAUSE,
		RELESE,
		
		//以下ゲーム内の演出
		PLAYER_WARP,
		ENEMY_GETWAIT,
		PLAYER_MISSWAIT,

		EXIT,
	};
	

	ConfigParser savedata;			// セーブデータ

	int timer;						// 汎用タイマー
	SCENE iSceneStatus;				//画面の状態
	int stage;						// ステージ
	int stage_start_count = 0;		// ステージ開始処理
	int stage_clear_count;			// ステージ開始処理
	int game_score = 0;				//スコア
	int hi_score = 0;				//ハイスコア
	int game_time_count = 0;		//ゲーム終了までの残り時間
	int menu_input = 0;				//敵を倒したときのWAITカウンタ
	int time = 0;

	Keypad keypad;					// キーボード/ゲームパッド取得用
	
	int kago_x = 320;
	int kago_y = 340;
	int red_teamscore = 0;
	int tama_count = 0;				//
	int tama_deathcount = 0;				//
	int bonus = 0;				//
	
	//エフェクト用構造体
	struct EFFECT_DATA
	{
		int exist;	//存在
		int type;	//透明度
		int timer;	//生存時間
		float pos_x;//位置
		float pos_y;//位置
		int r;	//
		int g;	//
		int b;	//
		int alpha;	//透明度
		float dir;	//方向
		float speed;//速度
		float zoom_x;	//
		float zoom_y;	//
		int image_x;
		int image_y;
		int image_w;
		int image_h;
		int anime;
		int anime_max;
		int anime_interinit;
		int anime_inter;
		int param1;
		int param2;
		int param3;
	};
	const int EFFECT_MAX = 128;
	EFFECT_DATA effect[EFFECT_MAX];

	struct TAMA_DATA
	{
		int exist;	//存在
		int type;	//透明度
		int timer;	//生存時間
		float jumpforce;	//ジャンプ力
		float pos_x;//位置
		float pos_y;//位置
		float rot;	//角度
		float rotadd;	//角度
		int r;	//
		int g;	//
		int b;	//
		int alpha;	//透明度
		float dir;	//方向
		float speed;//速度
		float zoom_x;	//
		float zoom_y;	//
		int image_x;
	};
	const int TAMA_MAX = 128;
	TAMA_DATA tama[TAMA_MAX];

	const int AZUKI_MAX = 1024;
	TAMA_DATA azuki[AZUKI_MAX];
	
	//-----------------------------------------------------------------------------
	//ゲーム別に使用される特別処理用変数
	//-----------------------------------------------------------------------------

	//-----------------------------------------------------------------------------
	//	コンストラクタ
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	this()
	{
		setMsg( GameState.MSG_NONE );
		// 各種初期化
		timer = 0;

		savedata          = new ConfigParser();
		keypad = new Keypad();
		keypad.SetUseCancel( false );

		iSceneStatus = SCENE.INIT;

	}

	
	//-----------------------------------------------------------------------------
	//	シーンの初期化
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void init( )
	{
Hell_write( "Gamecoer init\n" );
		//リソースの読み込み
		Hell_loadTexture("maptip","resource/image/maptip.bmp" , [0,255,0]);
		Hell_loadTexture("bg","resource/image/bg.bmp" , [0,255,0]);
		Hell_loadTexture("msg","resource/image/msg.bmp" , [0,255,0]);
		Hell_loadTexture("effect","resource/image/effect_ball.bmp" , [0,255,0]);
		Hell_loadTexture("menu","resource/image/menu.bmp" , [0,255,0]);


		//セーブデータ
		try
		{
			savedata.load(CONFIG_PATH);
		}
		catch(Exception e)
		{
			savedata.set("HI_SCORE",         999999);
			savedata.write();
		}
		hi_score = savedata.getint("HI_SCORE");

		game_time_count = 60 * 60 * 1;		//ゲーム終了までの残り時間
		red_teamscore = 0;
		time = 0;

Hell_write( "Gamecoer init\n" );

		iSceneStatus = SCENE.START;
		Hell_stopBgm( 1000 );

		Hell_randSeedTime();
		tama_count = 0;				//
		tama_deathcount = 0;
		bonus = 0;
//		create_effect( 3, 320, 280, 0, 0);


	}
	


	//-----------------------------------------------------------------------------
	//	シーンの後処理
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void relese( )
	{
		iSceneStatus = SCENE.EXIT;
	}
	//-----------------------------------------------------------------------------
	//	開始演出
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void SeneStart_move( )
	{
		int i;

		stage_start_count++;
		if ( stage_start_count == ( 60 * 3 ) )
		{
			Hell_playBgm( "resource/sound/bgm.ogg", -1, 0 );
			iSceneStatus = SCENE.MAIN;
		}
	}
	//-----------------------------------------------------------------------------
	//	ステージ開始表示処理
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void SeneStart_draw( )
	{
/*		
		if (stage_start_count < (60 * 4))
		{
			Hell_drawTexture("msg"
				, 0
				, 0
				, 0
				, 0
				, getScreenWidth( ) , getScreenHeight( )
				, 1.0 , 1.0 );
		}
*/
		int mx = 260;
		if ( stage_start_count < ( 60 * 1 ) )
		{
			Hell_drawFont(" 3 " , mx, 180 , 4 , 255,255,255);
		}
		else if ( stage_start_count < ( 60 * 2 ) )
		{
			Hell_drawFont(" 2 " , mx, 180 , 4 , 255,255,255);
		}
		else if ( stage_start_count < ( 60 * 3 ) )
		{
			Hell_drawFont(" 1 " , mx, 180 , 4 , 255,255,255);
		}
		else if ( ( stage_start_count >= ( 60 * 3 ) ) && (stage_start_count < (60 * 4)))
		{
			Hell_drawFont("GO!" , mx, 180 , 4 , 255,255,255);
		}
	}
	//-----------------------------------------------------------------------------
	//	クリア演出の処理
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void SeneClear_move( )
	{
		if ( stage_clear_count > ( 60 * 2 ) )
		{
			if( Hell_isPushMouse() )
			{
				iSceneStatus = SCENE.RELESE;
			}
		}
		else 
		{
			stage_clear_count++;
		}
		
		
	}
	//-----------------------------------------------------------------------------
	//	クリア演出の表示
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void SeneClear_draw( )
	{
		int min;
		int sec;
		int msec;
		char[] str;

		Hell_setAlpha(HELL_ALPHA_NORMAL);
//		Hell_drawFont( "HI SCORE" , 400, 10 , 2 , 255,255,255);
//		Hell_drawFont( std.string.toString( hi_score ) , 400, 30 , 4 , 255,255,255);

		Hell_drawFont( "RESULTS" , 200, 100 , 4 , 255,255,255);
/*
		min = ( game_score / 60 ) / 60;
		sec = ( game_score / 60 ) % 60;
		msec = game_score % 60;
		str = std.string.format( "%02d:%02d:%02d", min, sec, msec );
*/

		str = std.string.format( "BONUS:%d", bonus );
//		Hell_drawFont( "TIME" ,    210, 300 , 2 , 255,255,255);
		Hell_drawFont( str , 180, 150 , 4 , 255,255,255);

		str = std.string.format( "SCOER:%d", game_score );
//		Hell_drawFont( "TIME" ,    210, 300 , 2 , 255,255,255);
		Hell_drawFont( str , 180, 180 , 4 , 255,255,255);
/*
		if ( hi_score >= game_score )
		{
			Hell_drawFont( "NEW RECORD !",170, 390 , 4 , 255,255,255);
		}
*/
		if ( stage_clear_count > ( 60 * 2 ) )
		{
			Hell_drawFont("MOUSE BUTTON TO EXIT" , 150, 300 , 2 , 255,255,255);
		}
		else
		{
			Hell_drawFont(" OWARI !" , 200, 220 , 4 , 255,255,255);
		}
	}
	//-----------------------------------------------------------------------------
	//	ゲームオーバー演出
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void SeneEnd( )
	{
//		iSceneStatus = SCENE.MAIN;
	}
	
	//-----------------------------------------------------------------------------
	//	オブジェクトの動作
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void move()
	{
		
		switch( iSceneStatus )
		{
		case SCENE.INIT:
			//初期化
			init( );
			break;
		case SCENE.START:
			//開始
			SeneStart_move( );
			break;
		case SCENE.MAIN:
			keypad.update( );	//リプレイキー入力の更新
			//メイン
			tama_move( );
			azuki_move( );
			effect_move( );
			system_move( );
			SeneStart_move( );

			break;
		case SCENE.CLEAR:
			//クリア
			tama_move( );
			azuki_move( );
			effect_move( );
//			mob_move( );
			SeneClear_move( );
			break;
		case SCENE.END:
			//ゲームオーバー
			break;
		case SCENE.PAUSE:
			//一時停止
			pause_move( );
			break;
		case SCENE.RELESE:
			//後処理
			relese( );
			break;

		case SCENE.EXIT:
		default:
			//シーンの終了
			setMsg(GameState.MSG_REQ_TITLE);
			break;
		}
		
		time++;
		float xofs = getYure( 30, time * 2 );
		kago_x = 320 + cast(int)xofs;
		float yofs = getYure( 10, ( time ));
		kago_y = 340 + cast(int)yofs;
	}
	
	//-----------------------------------------------------------------------------
	//	オブジェクトの描画
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void draw()
	{
		// 作画開始
		Hell_begin();
		resetPerspective();
		Hell_setAlpha(HELL_ALPHA_NORMAL);
		
		switch( iSceneStatus )
		{
		case SCENE.INIT:
			//初期化
			break;
		case SCENE.START:
			//開始
			system_draw( );
			SeneStart_draw( );
			break;
		case SCENE.MAIN:
			//メイン
			system_draw( );
			tama_draw( );
			azuki_draw( );
			effect_draw( );
			SeneStart_draw( );
			break;
		case SCENE.CLEAR:
			//クリア
			system_draw( );
			tama_draw( );
			azuki_draw( );
			effect_draw( );
			SeneClear_draw( );
			break;
		case SCENE.END:
			//ゲームーバー
			system_draw( );
			SeneEnd( );
			break;
		case SCENE.PAUSE:
			//一時停止
			system_draw( );
			pause_draw( );
			break;
		case SCENE.RELESE:
			//後処理
			break;
			
			
		case SCENE.EXIT:
		default:
			break;
		}
// for debug code start
Hell_drawFPS( 550, 10 );
//Hell_drawFont( std.string.toString( cast( int )scroll_status ), 10, 10 * 1, 1 , 255,255,255 );
//Hell_drawFont( std.string.toString( cast( int )position.y ), 10, 10 * 2, 1 , 255,255,255 );
//Hell_drawFont( std.string.toString( cast( int )place ), 10, 10 * 3, 1 , 255,255,255 );
//Hell_drawFont( std.string.toString( cast( int )motion ), 10, 10 * 4, 1 , 255,255,255 );
//Hell_drawFont( std.string.toString( cast( int )debug_disp[0] ), 10, 10 * 5, 1 , 255,255,255 );
//Hell_drawFont( std.string.toString( cast( int )jump_fream_count ), 10, 10 * 6, 1 , 255,255,255 );
// for debug code end

	}
	
	// 画面サイズ取得
	int getScreenWidth(){return boot.g_width;}
	int getScreenHeight(){return boot.g_height;}
	
	string zfill(string str , int n)
	{
		for(int t=str.length;t<n;t++){
			str = "0" ~ str;
		}
		return str;
	}
	
	//-----------------------------------------------------------------------------
	//	ゲーム情報、システムの処理
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void system_move( )
	{
		//残り時間のカウント
		game_time_count--;

		bool make = false;
		if ( game_time_count > 60 * 40 )
		{
			if ( ( game_time_count % 22 ) == 0 )
			{
				make = true;
			}
		}
		else if ( game_time_count > 60 * 20 )
		{
			if ( ( game_time_count % 15 ) == 0 )
			{
				make = true;
			}
		}
		else if ( game_time_count > 60 * 0 )
		{
			if ( ( game_time_count % 8 ) == 0 )
			{
				make = true;
			}
		}
		
		if (make == true)
		{
			tama_count++;
			int type = 0;
			if ( ( tama_count % 20 ) == 15 )
			{
				type = 1;
			}
			else if ( ( tama_count % 6 ) == 4 )
			{
				type = 2;
			}
			
			int x = Hell_randInt(-50, 690);
			float dir = 0;
			if ( x > 320 )
			{
				dir = 180;
			}
			float spd = Hell_randInt(2, 8);
//			float spd = 5;
			create_tama( type, x, 400, dir, spd, -Hell_randInt(35, 50) );
		}

		if ( Hell_isPushMouse() )
		{
			Hell_playWAV( "shot", 0, -1 );
			int mx = Hell_getMouseX() / 2;
			int my = Hell_getMouseY() / 2;
			create_effect( 1, mx, my, 0, 0 );

		}

		if ( game_time_count == 0 )
		{
			
			Hell_playBgm( "resource/sound/results.ogg", 1, 0 );

			//ハイスコアの保存
			bonus = 100 - red_teamscore;
			game_score += bonus;
/*
			if ( hi_score > game_score )
			{
				keypad.save( "replay/replay_01.bin" );	//リプレイの保存
				hi_score = game_score;
				savedata.set("HI_SCORE",   cast(int)hi_score);
				savedata.write();
			}
*/
			iSceneStatus = SCENE.CLEAR;
		}
		
		if ( iSceneStatus == SCENE.MAIN )
		{
			if(keypad.isPushCancel(true))
			{
				//ポーズ
//				iSceneStatus = SCENE.PAUSE;
//				menu_input = 0;
			}
		}
	}
	//-----------------------------------------------------------------------------
	//	ゲーム情報、システムの描画
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void system_draw( )
	{
		int min;
		int sec;
		int msec;
		char[] str;
		int r = 255;
		int g = 255;
		int b = 255;

		Hell_setAlpha(HELL_ALPHA_NORMAL);
		Hell_drawTextureEx("bg"
			, 640 / 2
			, 360 / 2
			, 0
			, 0
			, 640,360 
			, 1.0 , 1.0
			, 0
			,255, 255, 255, 255 );
		
		tama_draw_oku( );
		
		Hell_drawTextureEx("maptip"
			, kago_x
			, kago_y
			, 0
			, 0
			, 400,100 
			, 1.0 , 1.0
			, 0
			,255, 255, 255, 255 );
		
		
		min = ( game_time_count / 60 ) / 60;
		sec = ( game_time_count / 60 ) % 60;
		msec = game_time_count % 60;
		
		if ( iSceneStatus != SCENE.CLEAR )
		{
			str = std.string.format( "TIME %2d:%02d:%02d", min, sec, msec );
		}
		Hell_setAlpha(HELL_ALPHA_NORMAL);
		Hell_drawFont( str , 120, 20 , 3 , r,g,b);

//		Hell_drawFont( "SCORE" , 10, 10 , 2 , 255,255,255);

		str = std.string.format( "RED TEAM:%d", red_teamscore );
		Hell_drawFont( str , 150, 330 , 3 , 255,255,255);

		str = std.string.format( "SCOER:%d", game_score );
		Hell_drawFont( str , 2, 2 , 2 , 255,255,255);
/*
		min = ( hi_score / 60 ) / 60;
		sec = ( hi_score / 60 ) % 60;
		msec = hi_score % 60;

		Hell_drawFont( "HI SCORE" , 300, 10 , 2 , 255,255,255);
		str = std.string.format( "%02d:%02d:%02d", min, sec, msec );
		Hell_drawFont( str , 300, 30 , 4 , 255,255,255);
*/	
		int mx = Hell_getMouseX() / 2;
		int my = Hell_getMouseY() / 2;
		Hell_drawTextureEx("maptip"
			, mx
			, my
			, 256
			, 416
			, 64, 64
			, 1 , 1
			, 0
			,255, 255, 255, 128 );

	}
	
	//-----------------------------------------------------------------------------
	//	ポーズの処理
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void pause_move( )
	{
		if(keypad.isPushUp(true))
		{
			Hell_playWAV( "select", 0, -1 );
			menu_input++;
			if ( menu_input > 1 )
			{
				menu_input = 0;
			}
		}
		else if(keypad.isPushDown(true))
		{
			Hell_playWAV( "select", 0, -1 );
			menu_input--;
			if ( menu_input < 0 )
			{
				menu_input = 1;
			}
		}
		if(keypad.isPushEnter(true))
		{
			switch ( menu_input )
			{
			case 0:
				//ポーズ解除
				iSceneStatus = SCENE.MAIN;
				break;
			case 1:
				//リトライ
				iSceneStatus = SCENE.RELESE;
				break;
			default:
				break;
			}
		}
		if(keypad.isPushCancel(true))
		{
			//ポーズ解除
			iSceneStatus = SCENE.MAIN;
		}
	}
	//-----------------------------------------------------------------------------
	//	ポーズの描画
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void pause_draw( )
	{
		Hell_setAlpha(HELL_ALPHA_NORMAL);
		Hell_drawTexture("menu"
			, 96 + 160
			, 64 + 120 + ( menu_input * 32 )
			, 320
			, 0
			, 32, 32
			, 1.0 , 1.0
			, 0
			,255, 255, 255, 255 );
		Hell_drawTexture("menu"
			, 160
			, 120
			, 0
			, 0
			, 320, 240
			, 1.0 , 1.0
			, 0
			,255, 255, 255, 255 );
	}
	
	
	//-----------------------------------------------------------------------------
	//	エフェクトの作成
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void create_effect( int type, float x, float y, float dir, float speed, int param1 = 0 )
	{
		int i = 0;
		for ( i = 0; i < EFFECT_MAX; i++ )
		{
			if ( effect[i].exist == 0 )
			{
				effect[i].exist = 1;	//存在
				effect[i].type = type;	//
				effect[i].timer = 0;	//生存時間
				effect[i].pos_x = x;	//位置
				effect[i].pos_y = y;	//位置
				effect[i].alpha = 255;	//透明度
				effect[i].dir = dir;	//
				effect[i].speed = speed;	//
				effect[i].param1 = param1;
				effect[i].param2 = 0;
				
				effect[i].r = 255;	//色
				effect[i].g = 255;	//色
				effect[i].b = 255;	//色
				effect[i].zoom_x = 1.0;	//拡大率
				effect[i].zoom_y = 1.0;	//拡大率
				//タイプによってパラメータを分けるといいかも
				switch (effect[i].type )
				{
				case 0:
					effect[i].r = Hell_randInt(0, 255);	//色
					effect[i].g = Hell_randInt(0, 255);	//色
					effect[i].b = Hell_randInt(0, 255);	//色
					effect[i].zoom_x = 0.5;	//拡大率
					effect[i].zoom_y = 0.5;	//拡大率
					break;
				case 1:
					effect[i].anime = 0;
					effect[i].anime_max = 4;
					effect[i].anime_interinit = 2;
					effect[i].anime_inter = effect[i].anime_interinit;
					break;
				case 2:
					break;
				case 3:
					effect[i].param2 = 10;
					effect[i].param3 = Hell_randInt(0, 10);
					break;
				case 4:
					effect[i].param3 = Hell_randInt(0, 360);
					break;
				default:
					break;
				}
				break;
			}
		}
	}
	//エフェクトの表示
	void effect_draw( )
	{
		char[] str;
		int i = 0;
		for ( i = 0; i < EFFECT_MAX; i++ )
		{
			if ( effect[i].exist != 0 )
			{
				Hell_setAlpha( HELL_ALPHA_ADD );	//加算半透明
				switch (effect[i].type )
				{
				case 0:
					Hell_drawTextureEx("effect"
						, effect[i].pos_x
						, effect[i].pos_y
						, 0
						, 0
						, 128, 128
						, effect[i].zoom_x , effect[i].zoom_y
						, 0
						,effect[i].r, effect[i].g, effect[i].b, effect[i].alpha );
					break;
				case 1:
					Hell_drawTextureEx("maptip"
						, effect[i].pos_x
						, effect[i].pos_y
						, 0 + ( effect[i].anime * 64)
						, 160
						, 64, 64
						, effect[i].zoom_x , effect[i].zoom_y
						, 0
						,effect[i].r, effect[i].g, effect[i].b, effect[i].alpha );
					
					break;
				case 2:
					Hell_setAlpha( HELL_ALPHA_NORMAL );	//加算半透明
					if ( effect[i].param1 < 0 )
					{
						str = std.string.format( "%dPTS", effect[i].param1 );
					}
					else
					{
						str = std.string.format( "+%dPTS", effect[i].param1 );
					}
					Hell_drawFont( str , cast(int)effect[i].pos_x, cast(int)effect[i].pos_y , 2 , 255,255,255);
					break;
				case 3:
					Hell_setAlpha( HELL_ALPHA_NORMAL );	//加算半透明
					Hell_drawTexture("maptip"
						, effect[i].pos_x
						, effect[i].pos_y + ( effect[i].param2 * effect[i].param2)
						, 0
						, 256
						, 320 + 64, 96
						, effect[i].zoom_x , effect[i].zoom_y
						, 0
						,effect[i].r, effect[i].g, effect[i].b, effect[i].alpha );
					Hell_drawTexture("msg"
						, effect[i].pos_x
						, effect[i].pos_y + ( effect[i].param2 * effect[i].param2)
						, 0
						, 0 + ( 32 * effect[i].param3 )
						, 512, 32
						, effect[i].zoom_x , effect[i].zoom_y
						, 0
						,effect[i].r, effect[i].g, effect[i].b, effect[i].alpha );
					break;
				case 4:
					Hell_setAlpha( HELL_ALPHA_NORMAL );	//加算半透明
					Hell_drawTexture("maptip"
						, effect[i].pos_x
						, effect[i].pos_y + ( effect[i].param2 * effect[i].param2)
						, 63
						, 416
						, 64, 64
						, 1 , 1
						, effect[i].param3
						,effect[i].r, effect[i].g, effect[i].b, effect[i].alpha );
					break;
				default:
					break;
				}
			}
		}
		Hell_setAlpha( HELL_ALPHA_NORMAL );			//通常半透明に戻す
	}
	//エフェクトの移動
	void effect_move( )
	{
		int i = 0;
		for ( i = 0; i < EFFECT_MAX; i++ )
		{
			if ( effect[i].exist != 0 )
			{
				effect[i].timer++;	//生存時間

				float vx = Hell_cosEx( effect[i].dir ) * effect[i].speed;
				float vy = Hell_sinEx( effect[i].dir ) * effect[i].speed;
				effect[i].pos_x += vx;	//位置
				effect[i].pos_y += vy;	//位置
	
				switch (effect[i].type )
				{
				case 0:
					//タイプによって動きを分けるといいかも
					effect[i].zoom_x -= 0.01;	//
					effect[i].zoom_y -= 0.01;	//
					if ( effect[i].zoom_x < 0.0 )
					{
						effect[i].zoom_x = 0.0;
					}
					if ( effect[i].zoom_y < 0.0 )
					{
						effect[i].zoom_y = 0.0;
						effect[i].exist = 0;	//消える 
					}
					break;
				case 1:
					effect[i].anime_inter--;
					if (effect[i].anime_inter <= 0)
					{
						effect[i].anime_inter = effect[i].anime_interinit;
						effect[i].anime++;
						if (effect[i].anime >= effect[i].anime_max)
						{
							effect[i].exist = 0;	//消える 
						}
					}
					
					break;
				case 2:
					if ( effect[i].timer > 60 )
					{
						effect[i].exist = 0;	//消える 
					}
					break;
				case 3:
					effect[i].param2--;
					if ( effect[i].param2 < 0 )
					{
						effect[i].param2 = 0;
					}
					if ( effect[i].timer > 180 )
					{
						effect[i].exist = 0;	//消える 
					}
					break;
				default:
					break;
				}
			}
		}
	}

	//-----------------------------------------------------------------------------
	//	玉の作成
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void create_tama( int type, float x, float y, float dir, float speed, float jumpforce )
	{
		int i = 0;
		for ( i = 0; i < TAMA_MAX; i++ )
		{
			if ( tama[i].exist == 0 )
			{
				tama[i].exist = 1;	//存在
				tama[i].type = type;	//
				tama[i].timer = 0;	//生存時間
				tama[i].pos_x = x;	//位置
				tama[i].pos_y = y;	//位置
				tama[i].alpha = 255;	//透明度
				tama[i].dir = dir;	//
				tama[i].speed = speed;	//
				tama[i].rot = Hell_randInt(0, 360);	//
				tama[i].rotadd = Hell_randInt(0, 90)-45;	//
				tama[i].jumpforce = jumpforce;
				
				//タイプによってパラメータを分けるといいかも
				tama[i].r = 255;	//色
				tama[i].g = 255;	//色
				tama[i].b = 255;	//色
				tama[i].zoom_x = 1;	//拡大率
				tama[i].zoom_y = 1;	//拡大率
				tama[i].image_x = 0;
				if ( type == 1 )
				{
					tama[i].image_x = 64;
				}
				if ( type == 2 )
				{
					tama[i].image_x = 128;
				}
				break;
			}
		}
	}
	//エフェクトの表示
	void tama_draw( )
	{
		int i = 0;
		for ( i = 0; i < TAMA_MAX; i++ )
		{
			if ( ( tama[i].exist != 0 ) && ( tama[i].jumpforce <= 0 ) )
			{
				Hell_setAlpha( HELL_ALPHA_NORMAL );			//通常半透明に戻す
				Hell_drawTextureEx("maptip"
					, tama[i].pos_x
					, tama[i].pos_y
					, 0 + tama[i].image_x
					, 416
					, 64, 64
					, tama[i].zoom_x , tama[i].zoom_y
					, tama[i].rot
					,tama[i].r, tama[i].g, tama[i].b, tama[i].alpha );
			}
		}
	}
	void tama_draw_oku( )
	{
		int i = 0;
		for ( i = 0; i < TAMA_MAX; i++ )
		{
			if ( ( tama[i].exist != 0 ) && ( tama[i].jumpforce > 0 ) )
			{
				Hell_setAlpha( HELL_ALPHA_NORMAL );			//通常半透明に戻す
				Hell_drawTextureEx("maptip"
					, tama[i].pos_x
					, tama[i].pos_y
					, 0 + tama[i].image_x
					, 416
					, 64, 64
					, tama[i].zoom_x , tama[i].zoom_y
					, tama[i].rot
					,tama[i].r, tama[i].g, tama[i].b, tama[i].alpha );
			}
		}
	}
	//エフェクトの移動
	void tama_move( )
	{
		int mx = Hell_getMouseX() / 2;
		int my = Hell_getMouseY() / 2;
		int i = 0;
		for ( i = 0; i < TAMA_MAX; i++ )
		{
			if ( tama[i].exist != 0 )
			{
				tama[i].timer++;	//生存時間

				tama[i].jumpforce += 0.98;
				float vx = Hell_cosEx( tama[i].dir ) * tama[i].speed;
				float vy = Hell_sinEx( tama[i].dir ) * tama[i].speed;
				tama[i].pos_x += vx;	//位置
				tama[i].pos_y += vy + ( tama[i].jumpforce / 3 );	//位置
//				tama[i].pos_y += vy;	//位置
				tama[i].rot += tama[i].rotadd;
				
				if ( tama[i].jumpforce > 0 )
				{
					if ( tama[i].pos_y > 400 )
					{
						tama[i].exist = 0;
					}
					
					if ( iSceneStatus == SCENE.MAIN )
					{
						if ( tama[i].pos_y > 360 )
						{
							if ( ( tama[i].pos_x > ( kago_x - 140 ) ) && ( tama[i].pos_x < ( kago_x + 140 ) ) )
							{
								Hell_playWAV( "in", 0, 1 );
								if ( tama[i].type == 0 )
								{
									red_teamscore++;
								}
								tama[i].exist = 0;
							}
						}
					}
				}
				
				//マウスとの判定
				if ( iSceneStatus == SCENE.MAIN )
				{
					if ( Hell_isPushMouse() )
					{
						if (( mx > ( tama[i].pos_x - 40 ) ) && ( mx < ( tama[i].pos_x + 40 ) ))
						{
							if (( my > ( tama[i].pos_y - 40 ) ) && ( my < ( tama[i].pos_y + 40 ) ))
							{
								//１ボタン
								tama[i].exist = 0;
								tama_deathcount++;
								int addscore = 1;
								if ( tama[i].type == 1 )
								{
									addscore = 10;
									Hell_playWAV( "hit2", 0, -1 );
									create_effect( 4, tama[i].pos_x, tama[i].pos_y, Hell_randInt(-90-45, -90+45), 20, 0 );
								}
								else if ( tama[i].type == 2 )
								{
									addscore = -5;
									Hell_playWAV( "hit1", 0, -1 );
									int j = 0;
									for ( j = 0; j < 32; j++ )
									{
										float spd = Hell_randInt(0, 8);
										int dir = Hell_randInt(0, 180);
										create_azuki( 0, tama[i].pos_x, tama[i].pos_y, dir, spd, -Hell_randInt(-10, +25) );
									}
								}
								else
								{
									Hell_playWAV( "hit1", 0, 2 );
									int j = 0;
									for ( j = 0; j < 32; j++ )
									{
										float spd = Hell_randInt(0, 8);
										int dir = Hell_randInt(0, 180);
										create_azuki( 0, tama[i].pos_x, tama[i].pos_y, dir, spd, -Hell_randInt(-10, +25) );
									}
								}
								game_score += addscore;
								create_effect( 2, tama[i].pos_x, tama[i].pos_y, -90, 1, addscore );
								int ei;
								for ( ei = 0; ei < 16; ei++ )
								{
									create_effect( 0, mx, my, Hell_randInt(0, 360), Hell_randInt(5, 20) );
								}
								if  ( ( tama_deathcount > 0 ) && ( ( tama_deathcount % 10 ) == 0 ) )
								{
									create_effect( 3, 320, 280, 0, 0);
								}
							}
						}
					}
				}
			}
		}
	}
	float getYure( float haba, int time )
	{
		float rc = Hell_cosEx( time ) * haba;
		return(rc);
	}
	//-----------------------------------------------------------------------------
	//	小豆の作成
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void create_azuki( int type, float x, float y, float dir, float speed, float jumpforce )
	{
		int i = 0;
		for ( i = 0; i < AZUKI_MAX; i++ )
		{
			if ( azuki[i].exist == 0 )
			{
				azuki[i].exist = 1;	//存在
				azuki[i].type = type;	//
				azuki[i].timer = 0;	//生存時間
				azuki[i].pos_x = x;	//位置
				azuki[i].pos_y = y;	//位置
				azuki[i].alpha = 255;	//透明度
				azuki[i].dir = dir;	//
				azuki[i].speed = speed;	//
				azuki[i].rot = Hell_randInt(0, 360);	//
				azuki[i].rotadd = Hell_randInt(0, 90)-45;	//
				azuki[i].jumpforce = jumpforce;
				
				//タイプによってパラメータを分けるといいかも
				azuki[i].r = 255;	//色
				azuki[i].g = 255;	//色
				azuki[i].b = 255;	//色
				azuki[i].zoom_x = 1;	//拡大率
				azuki[i].zoom_y = 1;	//拡大率
				azuki[i].image_x = 0;
				break;
			}
		}
	}
	//エフェクトの表示
	void azuki_draw( )
	{
		int i = 0;
		for ( i = 0; i < AZUKI_MAX; i++ )
		{
			if ( azuki[i].exist != 0 )
			{
				Hell_drawCircle(azuki[i].pos_x, azuki[i].pos_y, 2, 0, 108, 0, 14, 255);
			}
		}
	}
	//エフェクトの移動
	void azuki_move( )
	{
		int i = 0;
		for ( i = 0; i < AZUKI_MAX; i++ )
		{
			if ( azuki[i].exist != 0 )
			{
				azuki[i].timer++;	//生存時間

				azuki[i].jumpforce += 0.98;
				float vx = Hell_cosEx( azuki[i].dir ) * azuki[i].speed;
				float vy = Hell_sinEx( azuki[i].dir ) * azuki[i].speed;
				azuki[i].pos_x += vx;	//位置
				azuki[i].pos_y += vy + ( azuki[i].jumpforce / 3 );	//位置
//				azuki[i].pos_y += vy;	//位置
				azuki[i].rot += azuki[i].rotadd;
				
				if ( azuki[i].jumpforce > 0 )
				{
					if ( azuki[i].pos_y > 400 )
					{
						azuki[i].exist = 0;
					}
				}
			}
		}
	}

}



